Package ghidra.service.graph

# Class GraphType

java.lang.Object
ghidra.service.graph.GraphType

Direct Known Subclasses:
  `EmptyGraphType`, `ProgramGraphType`

public class GraphType extends Object
Class that defines a new graph type. It defines the set of valid vertex and edge types

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `GraphType(String name, String description, List<String> vertexTypes, List<String> edgeTypes)`
  Constructs a new GraphType

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `containsEdgeType(String edgeType)`
  Test if the given string is a valid edge type
  `boolean`
  `containsVertexType(String vertexType)`
  Test if the given string is a valid vertex type
  `boolean`
  `equals(Object obj)`
  `String`
  `getDescription()`
  Returns a description for this type of graph
  `List<String>`
  `getEdgeTypes()`
  Returns a list of valid edge types for graphs of this type
  `String`
  `getName()`
  Returns a name for this type of graph
  `String`
  `getOptionsName()`
  `List<String>`
  `getVertexTypes()`
  Returns a list of valid vertex types for graphs of this type
  `int`
  `hashCode()`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### GraphType

    public GraphType(String name, String description, List<String> vertexTypes, List<String> edgeTypes)
    Constructs a new GraphType
    Parameters:
      `name` - the name of this GraphType instance
      `description` - a brief description for graphs of this type
      `vertexTypes` - a list of all valid vertex types for graphs of this type
      `edgeTypes` - a list of all valid edge types for graphs of this type

- ## Method Details

  - ### getName

    public String getName()
    Returns a name for this type of graph
    Returns:
      a name of this type of graph

  - ### getDescription

    public String getDescription()
    Returns a description for this type of graph
    Returns:
      a description for this type of graph

  - ### getVertexTypes

    public List<String> getVertexTypes()
    Returns a list of valid vertex types for graphs of this type
    Returns:
      a list of valid vertex types for graphs of this type

  - ### getEdgeTypes

    public List<String> getEdgeTypes()
    Returns a list of valid edge types for graphs of this type
    Returns:
      a list of valid edge types for graphs of this type

  - ### containsVertexType

    public boolean containsVertexType(String vertexType)
    Test if the given string is a valid vertex type
    Parameters:
      `vertexType` - the string to test for being a valid vertex type
    Returns:
      true if the given string is a valid vertex type

  - ### containsEdgeType

    public boolean containsEdgeType(String edgeType)
    Test if the given string is a valid edge type
    Parameters:
      `edgeType` - the string to test for being a valid edge type
    Returns:
      true if the given string is a valid edge type

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### equals

    public boolean equals(Object obj)
    Overrides:
      `equals` in class `Object`

  - ### getOptionsName

    public String getOptionsName()